Summary:           Program for managing links into a DRBD shared partition
Name:              drbdlinks
Version:           1.29
Release:    1%{?dist}
License:           GPL-2.0-only
URL:               https://www.tummy.com/software/drbdlinks/
Source0:           https://github.com/linsomniac/%{name}/archive/release-%{version}/%{name}-%{version}.tar.gz
Source1:           drbdlinks.logrotate
Source2:           drbdlinksclean.service
Source3:           drbdlinksclean-wrapper
Requires:          python3
BuildRequires:     python3-devel
BuildRequires:     make
BuildRequires:     systemd-rpm-macros
BuildArch:         noarch
%{?systemd_requires}

%description
The drbdlinks program manages links into a DRBD partition which is shared
among several machines. A simple configuration file, "/etc/drbdlinks.conf",
specifies the links. This can be used to manage e.g. links for /etc/httpd,
/var/lib/pgsql and other system directories that need to appear as if they
are local to the system when running applications after the drbd shared
partition has been mounted.

When running drbdlinks with "start" as the mode, drbdlinks will rename the
existing files/directories and then make symbolic links into the DRBD
partition, "stop" does the reverse. By default, rename appends ".drbdlinks"
to the name, but this can be overridden.

%prep
%setup -q -n %{name}-release-%{version}

%build

%install
install -D -p -m 755 %{name} %{buildroot}%{_sbindir}/%{name}
sed -e '1 s|^#!.*python|#!%{__python3}|g' -i %{buildroot}%{_sbindir}/%{name}
touch -c -r %{name} %{buildroot}%{_sbindir}/%{name}
mkdir -p %{buildroot}{%{_sysconfdir}/%{name}.d,/usr/lib/ocf/resource.d/tummy}/
ln -s ../../../../..%{_sbindir}/%{name} %{buildroot}/usr/lib/ocf/resource.d/tummy/%{name}
install -D -p -m 644 %{name}.conf %{buildroot}%{_sysconfdir}/%{name}.conf
install -D -p -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/drbdlinksclean.service
install -D -p -m 755 %{SOURCE3} %{buildroot}%{_libexecdir}/drbdlinksclean
install -D -p -m 644 %{name}.8 %{buildroot}%{_mandir}/man8/%{name}.8
install -D -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/configs-to-clean

mv -f README.markdown README

%check
make -C tests DRBDLINKS=%{buildroot}%{_sbindir}/%{name}

%post
%systemd_post drbdlinksclean.service

%preun
%systemd_preun drbdlinksclean.service

%postun
%systemd_postun drbdlinksclean.service

%files
%license LICENSE
%doc README WHATSNEW
%{_unitdir}/drbdlinksclean.service
%{_libexecdir}/drbdlinksclean
%config(noreplace) %{_sysconfdir}/%{name}.conf
%dir %{_sysconfdir}/%{name}.d/
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sbindir}/%{name}
/usr/lib/ocf/resource.d/tummy/
%{_mandir}/man8/%{name}.8*
%{_localstatedir}/lib/%{name}/

%changelog
* Wed Aug 14 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.29-1
- initial build
